/* brinkmateRecord.h
 */
#ifndef OSL_BRINKMATE_BRINKMATERECORD
#define OSL_BRINKMATE_BRINKMATERECORD

#include "osl/brinkmate/configuration.h"
#include "osl/stl/vector.h"
#include "osl/move.h"
namespace osl
{
  namespace brinkmate
  {
    enum BrinkmateResult {
      /** sentinel */
      WORST_DEFENSE,
      CHECKMATE,
      /** ϥѥ᡼¸ */
      BRINKMATE,
      UNKNOWN,
      /** ϥѥ᡼¸ */
      NOT_BRINKMATE,
      LOOP_DETECTION,
      INVERSE_CHECKMATE,
      /** sentinel */
      WORST_ATTACK,
    };
    inline bool isAttackSuccess(BrinkmateResult result)
    {
      return result < UNKNOWN;
    }
    inline bool isDefenseSuccess(BrinkmateResult result)
    {
      return result > UNKNOWN;
    }
    inline bool isSearchResult(BrinkmateResult result)
    {
      return (result > WORST_DEFENSE) && (result < WORST_ATTACK)
	&& (result != UNKNOWN);
    }
    inline BrinkmateResult betterForAttack(BrinkmateResult l, BrinkmateResult r)
    {
      return (l < r) ? l : r;
    }
    inline BrinkmateResult betterForDefense(BrinkmateResult l, BrinkmateResult r)
    {
      return (l > r) ? l : r;
    }

    struct BrinkmateRecord
    {
      typedef vector<Move> vector_t;
      vector_t moves;
      Configuration conf;
      Move best_move;
      BrinkmateResult result;
      int visit_count;
      bool is_visited;

      BrinkmateRecord() : result(UNKNOWN), visit_count(0), is_visited(false)
      {
      }
    };
    
  } // namespace brinkmate
} // namespace osl

#endif /* OSL_BRINKMATE_BRINKMATERECORD */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
