#ifndef _PROOFTREEDEPTH_H
#define _PROOFTREEDEPTH_H
#include "osl/hash/hashKey.h"
#include <boost/scoped_ptr.hpp>
namespace osl
{
  namespace state
  {
    class NumEffectState;
  }
  namespace checkmate
  {
    class CheckHashRecord;
    class DfpnTable;
    namespace analyzer
    {
      /**
       * ͤޤǤμ.
       * ;롼ǡ̵̹ʤɤޤޤ뤿
       * ʹ֤δФȰפȤϸ¤ʤ
       */
      class ProofTreeDepth
      {
	class Table;
	boost::scoped_ptr<Table> table;
      public:
	ProofTreeDepth();
	~ProofTreeDepth();
	int depth(const CheckHashRecord *record, bool is_or_node) const;
      private:
	int orNode(const CheckHashRecord *record) const;
	int andNode(const CheckHashRecord *record) const;
      };

      class ProofTreeDepthDfpn
      {
	class Table;
	boost::scoped_ptr<Table> table;
      public:
	explicit ProofTreeDepthDfpn(const DfpnTable& table);
	~ProofTreeDepthDfpn();
	int depth(const HashKey& key, const state::NumEffectState& state, bool is_or_node) const;
      private:
	int orNode(const HashKey& key) const;
	int andNode(const HashKey& key) const;
      };
    } // namespace analyzer
  } // namespace checkmate
}

#endif /* _PROOFTREEDEPTH_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
