#ifndef _DIRECTION_H
#define _DIRECTION_H
#include <cassert>
#include <iosfwd>

namespace osl
{
  enum Direction{
    UL=0,
    U=1,
    UR=2,
    L=3,
    R=4,
    DL=5,
    D=6,
    DR=7,
    UUL=8,
    UUR=9,
    LONG_UL=10,
    LONG_U=11,
    LONG_UR=12,
    LONG_L=13,
    LONG_R=14,
    LONG_DL=15,
    LONG_D=16,
    LONG_DR=17,
    DIRECTION_MIN=0,
    SHORT_DIRECTION_MAX=9,
    SHORT_DIRECTION_SIZE=10,
    DIRECTION_MAX=17,
    DIRECTION_SIZE=18
  };
  
  inline bool isShort(Direction d){
    return d<LONG_UL;
  }

  inline bool isLong(Direction d){
    return d>=LONG_UL;
  }

  inline Direction inverse(Direction d){
    assert(d <= DR);
    return static_cast<Direction>(7 - d);
  }

  bool isValid(Direction d);
  
  inline Direction longToShort(Direction d){
    assert(isLong(d));
    return static_cast<Direction>(static_cast<int>(d)-LONG_UL);
  }
  
  /**
   *  longDirͿƤϤʤ
   */
  inline Direction shortToLong(Direction d){
    assert(isShort(d));
    return static_cast<Direction>(static_cast<int>(d)+LONG_UL);
  }

  inline int dirToMask(Direction dir){
    return (1<<static_cast<int>(dir));
  }
  
  std::ostream& operator<<(std::ostream& os,const Direction d);
}
#endif /* _DIRECTION_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
