#ifndef _EFFECTED_NUM_TABLE_H
#define _EFFECTED_NUM_TABLE_H
#include "osl/state/simpleState.h"
#include <iosfwd>
namespace osl
{
  namespace effect
  {
    union Byte8 {
      unsigned long long lv;
      CArray<unsigned char,8> uc;
    }  __attribute__((aligned(8)));
    /**
     * ̾ζ𤬡ֹ鸫ĹĤƤˡ
     * ĤƤֹ
     * ȤСUλϲĹĤƤΤȤ롥
     * ĤƤʤEMPTY_NUM(0xff)Ƥ
     */
    class EffectedNum
    {
    private:
      Byte8 b8;
    public:
      EffectedNum() { clear(); }
      void clear(){
	b8.lv= 0xffffffffffffffffull;
      }
      int operator[](Direction d) const{
	assert(0<=d && d<=7);
	return b8.uc[d];
      }
      unsigned char& operator[](Direction d){
	assert(0<=d && d<=7);
	return b8.uc[d];
      }
    };
    class EffectedNumTable
    {
      CArray<EffectedNum,40> contents  __attribute__((aligned(16)));
    public:
      EffectedNumTable() { clear(); }
      EffectedNumTable(SimpleState const&);
      const EffectedNum& operator[](int i) const {
	return contents[i];
      }
      void clear();
      EffectedNum& operator[](int i){
	return contents[i];
      }
    };
    bool operator==(const EffectedNumTable&,const EffectedNumTable&);
    std::ostream& operator<<(std::ostream&,const EffectedNumTable&);
  }
  using effect::EffectedNumTable;
}

#endif // _EFFECTED_NUM_TABLE_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
