/* liberty8Table.h
 */
#ifndef _LIBERTY8TABLE_H
#define _LIBERTY8TABLE_H
#include "osl/ptype.h"
#include "osl/ptypeTable.h"
#include "osl/container/nearMask.h"
#include "osl/misc/carray.h"
#include "osl/misc/carray2d.h"
#include <iosfwd>
namespace osl
{
  namespace effect
  {
  /**
   * 8˵ΤɤĹĤ.
   * 3˵Ĳǽ뤬˺Ǥᤤ˵ؤ
   * եåȤ֤
   */
  struct LongEffect8
  {
    friend std::ostream& operator<<(std::ostream& os,LongEffect8 const& longEffect); 
    /**
     * ľʼ®褦
     */
    char smallOffset;
    CArray<unsigned char,3> mask;
  public:
    LongEffect8():smallOffset(0){
      mask[0]=mask[1]=mask[2]=0;
    }
    Offset getOffset() const{
      return Offset::makeDirect(smallOffset);
    }
    void setOffset(Offset o){
      smallOffset=static_cast<char>(o.intValue());
    }
    unsigned int getMask(int index) const{
      return static_cast<unsigned int>(mask[index]);
    }
    void setMask(int index,unsigned int val) {
      mask[index]=static_cast<unsigned char>(val);
    }
  };
    /**
     * Liberty8뤿˻Ȥơ֥.
     * û˴ؤƤϡptypeȺɸκǥơ֥롥
     * ĹgetLongEffect뤬
     * ֤˴ؤƤϤ˲ägetLongEffect2Ȥ.
     */
  class Liberty8Table{
    CArray<CArray<unsigned char,Offset32::SIZE>,PTYPE_SIZE> shortMask;
    CArray2d<LongEffect8,PTYPE_SIZE,Offset32::SIZE> longEffect;
    CArray<LongEffect8,Offset32::SIZE> longEffect2;
    LongEffect8 longEffectOf(Ptype ptype,int dx,int dy);
  public:
    Liberty8Table();
    /**
     * P¦ptypefromˤtoˤ Pȿ¦ζμ
     * ˤɤû(Ĺ٤򿭤Ф8˵
     * Ф)Ĥ֤
     * directǤʤƤ,targetζ򶴤ȿ¦ʤOKȤ
     * Ȥ0ǤǤʤȤ1Ȥ
     */
     template<Player P>
    NearMask getShortMask(Ptype ptype,Position from, Position to) const{
      assert(isValid(ptype) && from.isOnBoard() && to.isOnBoard());
      Offset32 offset32=Offset32(to,from).blackOffset32<P>();
      return NearMask::makeDirect(shortMask[ptype][offset32.index()]);
    }
    /**
     * P¦ptypefromˤtoˤ Pȿ¦ζμ
     * ˤɤĹ(Ĺ٤򿭤Ф8˵
     * Фޤ)Ĥ֤
     */
    template<Player P>
    LongEffect8 getLongEffect(Ptype ptype,Position from, Position to) const{
      assert(isValid(ptype) && from.isOnBoard() && to.isOnBoard());
      assert(Ptype_Table.hasLongMove(ptype));
      Offset32 offset32=Offset32(to,from).blackOffset32<P>();
      return longEffect[ptype][offset32.index()];
    }
    /**
     * , ζμФΰ֤ˤ, ξĹľ
     * ơ֥
     */
    template<Player P>
    LongEffect8 getLongEffect2(Position from, Position to) const{
      assert(from.isOnBoard() && to.isOnBoard());
      Offset32 offset32=Offset32(to,from).blackOffset32<P>();
      return longEffect2[offset32.index()];
    }
  };

  extern const Liberty8Table Liberty8_Table;
} // namespace effect
} // namespace osl
#endif /* _LIBERTY8TABLE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:

