#ifndef _BETTER_TO_PROMOTE_MOVE_ACTION_H
#define _BETTER_TO_PROMOTE_MOVE_ACTION_H
#include "osl/move_action/concept.h"
namespace osl
{
  namespace effect_action
  {
    /**
     * Τ
     */
    template<class Action>
    class BetterToPromote
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    private:
      const NumEffectState& state;
      Action & ac;
    public:
      BetterToPromote(const NumEffectState& s, Action& a) 
	: state(s), ac(a)
      {
      }
      template<Player P,Ptype Type>
      void doActionPtype(Piece p1,Position to){
	Position from=p1.position();
	Ptype ptype=p1.ptype();
	if(!isPromoted(ptype) && 
	   (to.canPromote<P>() || from.canPromote<P>()))
	  ac.unknownMove(from,to,state.getPieceAt(to),promote(Type),true,P);
	else
	  ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
      }
      template<Player P>
      void doAction(Piece p1,Position to){
	Position from=p1.position();
	Ptype ptype=p1.ptype();
	if(!isPromoted(ptype) && 
	   (to.canPromote<P>() || from.canPromote<P>()))
	  ac.unknownMove(from,to,state.getPieceAt(to),promote(ptype),true,P);
	else
	  ac.unknownMove(from,to,state.getPieceAt(to),ptype,false,P);
      }
      bool done() const{ return false; }
    };
  } // namespace effect_action
} // namespace osl
#endif // BETTER_TO_PROMOTE_MOVE_ACTION_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
