/* alphaBetaPlayer.h
 */
#ifndef GAMEPLAYING_ALPHABETAPLAYER_H
#define GAMEPLAYING_ALPHABETAPLAYER_H

#include "osl/game_playing/searchPlayer.h"
#include <boost/scoped_ptr.hpp>

namespace osl
{
  namespace game_playing
  {
    class AlphaBeta2ProgressEvalPlayer : public SearchPlayer
    {
    public:
      AlphaBeta2ProgressEvalPlayer();
      ~AlphaBeta2ProgressEvalPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, const search::TimeAssigned&);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };

    class AlphaBeta2TestEvalPlayer : public SearchPlayer
    {
    public:
      AlphaBeta2TestEvalPlayer();
      ~AlphaBeta2TestEvalPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, const search::TimeAssigned&);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };

    class AlphaBeta3TestEvalPlayer : public SearchPlayer
    {
    public:
      AlphaBeta3TestEvalPlayer();
      ~AlphaBeta3TestEvalPlayer();
      ComputerPlayer* clone() const;

      const MoveWithComment searchWithSecondsForThisMove(const GameState&, const search::TimeAssigned&);
      bool isReasonableMove(const GameState&, Move move, int pawn_sacrifice);
    };
  } // namespace game_playing
} // namespace osl

#endif /* GAMEPLAYING_ALPHABETAPLAYER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
