/* nonBlockDelete.h
 */
#ifndef _NONBLOCKDELETE_H
#define _NONBLOCKDELETE_H

#include <boost/shared_ptr.hpp>
#include <boost/utility.hpp>

namespace osl
{
  namespace misc
  {
    class NonBlockDelete : boost::noncopyable
    {
    public:
      /** ̥åɤ˾õꤹ */
      template <class T>
      static void planDelete(T *ptr)
      {
	boost::shared_ptr<void> holder(ptr); // shared_ptr preserves T
	resetAny(holder);
      }

      /**
       * make ptr empty immediately
       */
      template <class T>
      static void reset(boost::shared_ptr<T>& ptr)
      {
#ifndef DISABLE_NON_BLOCK_DELETE
	boost::shared_ptr<void> holder;
	holder = ptr;
#endif
	ptr.reset();
#ifndef DISABLE_NON_BLOCK_DELETE
	resetAny(holder);
#endif
      }
      static void resetAny(boost::shared_ptr<void>&);

      /**
       * ˤʤޤԤĤޤϼʬǾõ 
       * @return ϤǾä
       */
      static void deleteAll();
      static int waiting();
    private:
      static NonBlockDelete& instance();

      NonBlockDelete();
      ~NonBlockDelete();
      void push_back(boost::shared_ptr<void>&);

      class Queue;
      boost::shared_ptr<Queue> queue;

      class Runner;
      friend class Runner;
    };
    
  }
  using misc::NonBlockDelete;
}

#endif /* _NONBLOCKDELETE_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
