#ifndef _GENERATE_ALL_MOVES_H
#define _GENERATE_ALL_MOVES_H
#include "osl/state/numEffectState.h"
#include "osl/misc/loki.h"
#include "osl/move_action/concept.h"
#include "osl/container/bitXmask.h"
#include <boost/static_assert.hpp>

namespace osl
{
  namespace container
  {    
    class MoveVector;
  }
  namespace move_generator
  {
    /**
     * Ƥμ
     *
     * @param Action move_action
     */
    template<class Action>
    class AllMoves
    {
      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
    public:
      template<Player P,Ptype Type>
      static void generateMovesPtype(const NumEffectState& state, Action& action);

      template<Player P>
      static void generateMovesOnBoard(const NumEffectState& state, Action& action);

      /**
       * StatepawnMaskʤ
       * pawnMaskʤ
       * pawn
       */
      template<Player P>
      static void generateMovesPawn(const NumEffectState& state, Action& action,BitXmask& pawnMask);

      template<Player P>
      static void generateMoves(const NumEffectState& state, Action& action);

      template<Player P>
      static void generateMoves(const NumEffectState& state, Action& action,Int2Type<true> stateHasPawnMask);
      template<Player P>
      static void generateMoves(const NumEffectState& state, Action& action,Int2Type<false> stateHasPawnMask);


      static void generateMoves(Player p, const NumEffectState& state, Action& action)
      {
	if(p==BLACK)
	  generateMoves<BLACK>(state,action);
	else
	  generateMoves<WHITE>(state,action);
      }
    };

  } // namespace move_generator

  struct GenerateAllMoves
  {
    static void generate(Player p, const NumEffectState& state, container::MoveVector&);
  };
} // namespace osl

#endif /* _GENERATE_ALL_MOVES_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
