#ifndef _GENERATE_ALL_MOVES_TCC
#define _GENERATE_ALL_MOVES_TCC
#include "osl/move_generator/allMoves.h"
#include "osl/move_generator/pieceOnBoard.tcc"
#include "osl/move_generator/drop.h"
#include "osl/move_action/concept.h"
#include "osl/move_action/store.h"
#include "osl/state/numEffectState.h"

namespace osl
{
  namespace move_generator
  {
    /**
     * promtoeǽTλ
     */
    template<typename Action,Player P,Ptype T>
    struct EachOnBoard
    {
      const NumEffectState& state;
      Action& action;
      EachOnBoard(const NumEffectState& state,Action& action):state(state),action(action){}
      void operator()(Piece p){
	PieceOnBoardType<P,T>::generate(state,p,action);
      }
    };

    template<class Action>
    template<Player P,Ptype T>
    void AllMoves<Action>::
    generateMovesPtype(const NumEffectState& state, Action& action){
      typedef EachOnBoard<Action,P,T> each_t;
      each_t eachOnBoard(state,action);
      state.template forEachOnBoard<P,T,each_t>(eachOnBoard);
    }


    template<class Action>
    template<Player P>
    void AllMoves<Action>::
    generateMovesOnBoard(const NumEffectState& state, Action& action)
    {
      generateMovesPtype<P,PAWN>(state,action);
      generateMovesPtype<P,LANCE>(state,action);
      generateMovesPtype<P,KNIGHT>(state,action);
      generateMovesPtype<P,SILVER>(state,action);
      generateMovesPtype<P,GOLD>(state,action);
      generateMovesPtype<P,BISHOP>(state,action);
      generateMovesPtype<P,ROOK>(state,action);
      generateMovesPtype<P,KING>(state,action);
    }
    
    /**
     * ٤Ƥμ
     * StatePawnMaskľ
     */
    template<class Action>
    template<Player P>
    void AllMoves<Action>::
    generateMoves(const NumEffectState& state, Action& action,Int2Type<true>)
    {
      generateMovesOnBoard<P>(state, action);
      Drop<Action>::template generateMoves<P>(state,action);
    }

    /**
     * promtoeǽTλ
     */
    template<typename Action,Player P>
    struct EachOnBoardWithPawnMask{
      const NumEffectState& state;
      Action& action;
      BitXmask &pawnMask;
      EachOnBoardWithPawnMask(const NumEffectState& state,Action& action,BitXmask& pawnMask):state(state),action(action),pawnMask(pawnMask){}
      void operator()(Piece p){
	PieceOnBoard<P>::generateMovesPawn(state,p,action,pawnMask);
      }
    };

    template<class Action>
    template<Player P>
    void AllMoves<Action>::
    generateMovesPawn(const NumEffectState& state, Action& action,BitXmask &pawnMask){
      typedef EachOnBoardWithPawnMask<Action,P> each_t;
      each_t eachOnBoard(state,action,pawnMask);
      state.template forEachOnBoard<P,PAWN,each_t>(eachOnBoard);
    }

    /**
     * ٤Ƥμ
     * StatePawnMaskʤ
     */
    template<class Action>
    template<Player P>
    void AllMoves<Action>::
    generateMoves(const NumEffectState& state, Action& action,Int2Type<false>)
    {
      /**
       * pawnäƤʤpawnMaskϵˤʤƤɤ
       */
      BitXmask pawnMask;;
      if(state.template hasPieceInStand<P,PAWN>()){
	generateMovesPawn<P>(state,action,pawnMask);
      }
      else{
	generateMovesPtype<P,PAWN>(state,action);
      }
      generateMovesPtype<P,LANCE>(state,action);
      generateMovesPtype<P,KNIGHT>(state,action);
      generateMovesPtype<P,SILVER>(state,action);
      generateMovesPtype<P,GOLD>(state,action);
      generateMovesPtype<P,BISHOP>(state,action);
      generateMovesPtype<P,ROOK>(state,action);
      generateMovesPtype<P,KING>(state,action);
      Drop<Action>::template generateMovesWithPawnMask<P>(state,action,pawnMask);
    }

    /**
     * ٤Ƥμ
     * StatepawnMaskĤɤ dispatch
     */
    template<class Action>
    template<Player P>
    void AllMoves<Action>::
    generateMoves(const NumEffectState& state, Action& action){
      AllMoves<Action>::template
	generateMoves<P>(state,action,Int2Type<NumEffectState::hasPawnMask>());
    }


  } // namespace move_generator
} // namespace osl

#endif /* _GENERATE_ALL_MOVES_TCC */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
