/* fixedEval.h
 */
#ifndef SEARCH_FIXEDEVAL_H
#define SEARCH_FIXEDEVAL_H

#include "osl/eval/evalTraits.h"

namespace osl
{
  namespace search
  {
    class FixedEval
    {
      int draw_value;
    protected:
      ~FixedEval() {}
    public:
      FixedEval() : draw_value(0)
      {
      }
      void setDrawValue(int value) 
      {
	draw_value = value;
      }
      int drawValue() const { return draw_value; }

      /**
       * βꡤ.
       * θоݳμϵͤɾ򲼤롥
       */
      static int winByFoul(Player P) 
      {
	return eval::convert(P, EvalTraits<BLACK>::MAX_VALUE);
      }
      /**
       * 롼.
       * θоݳμϵͤɾ򲼤롥
       */
      static int winByLoop(Player P) 
      {
	return winByFoul(P);
      }
      /**
       * ͤˤ뾡
       */
      static int winByCheckmate(Player P)
      {
	return eval::convert(P, EvalTraits<BLACK>::MAX_VALUE-2);
      }
      /**
       * õwindowβ (餱Ǥ⹹)
       */
      static int minusInfty(Player P)
      {
	return winByCheckmate(alt(P));
      }
      /**
       * ͤۤо. (). loopޤ
       */
      static int winThreshold(Player P) 
      {
	return eval::convert(P, EvalTraits<BLACK>::MAX_VALUE-3);
      }
      /**
       * õựϰ ()
       */
      static int windowMax(Player P) 
      {
	return winByCheckmate(P);
      }
      /**
       * ɬ(˸)̤ɾ
       * P餱
       * @param limit  礭Ǥɬ
       */
      static int brinkmatePenalty(Player P, int limit)
      {
	return (winByFoul(alt(P))*3/4+eval::convert(alt(P), limit*16)) & (~1);
      }
      /**
       * üǵͤäƤΥڥʥƥ.
       * P ˵ͤäƤ threatmatePenalty(P)­
       */
      static int threatmatePenalty(Player P)
      {
	return winByFoul(alt(P))/2;
      }
      /**
       * ɤ. loopޤ
       */
      static int isWinValue(Player P, int val) 
      {
	return eval::notLessThan(P, val, winByCheckmate(P));
      }
    };
  } // namespace search
} // namespace osl

#endif /* SEARCH_FIXEDEVAL_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
