/* moveStackRejections.h
 */
#ifndef _MOVE_STACK_REJECTIONS_H
#define _MOVE_STACK_REJECTIONS_H
#include "osl/state/numEffectState.h"
#include "osl/container/moveStack.h"
#include "osl/misc/carray.h"
#include <iosfwd>

namespace osl
{
  namespace search
  {
    /**
     * Moveʬ򤷤ʬǤΤ̾ζ˴ؤݻǡ
     * pos, ptypeOshort롥
     */
    struct OnBoardElement {
      short posPtypeO;
      OnBoardElement() {}
      OnBoardElement(Position pos_,PtypeO ptypeO_){
	posPtypeO=makePosPtypeO(pos_,ptypeO_);
      }
      static short makePosPtypeO(Position pos,PtypeO ptypeO)
      {
	return static_cast<short>(pos.uintValue()+(ptypeO<<8));
      }
      Position pos() const{
	return Position::makeDirect(posPtypeO&0xff);
      }
      PtypeO ptypeO() const{
	return static_cast<PtypeO>(posPtypeO>>8);
      }
    };
    /**
     * Moveʬ򤷤ʬǤΤΤߤ롥
     * λ»ʤ®ȽǤ롥
     */
    struct StandElements {
      union {
	CArray<char,8> c8;
	unsigned long long l8;
      } v;
      StandElements() { v.l8=0x8080808080808080ull; }
      /**
       * altPˤȤä
       */
      void add(Ptype ptype){
	assert(ptype>=PTYPE_BASIC_MIN);
	v.c8[ptype-PTYPE_BASIC_MIN]++;
      }
      /**
       * altPˤȤäƸ
       */
      void sub(Ptype ptype){
	assert(ptype>=PTYPE_BASIC_MIN);
	v.c8[ptype-PTYPE_BASIC_MIN]--;
      }
      bool isZero() const{
	return v.l8==0x8080808080808080ull;
      }
      bool gtZero() const{
	return !isZero() && geZero();
      }
      bool geZero() const{
	return (v.l8&0x8080808080808080ull)==0x8080808080808080ull;
      }
      bool gegtZero(bool notRejectSennichite) const{
	if(notRejectSennichite) return gtZero();
	else return geZero();
      }
    };
    /**
     * ʣmoveˤ뺹ʬʬ򤷤
     * moveOnBoarPlusϼ֤ζΤ
     *             OnBoardMinusϼ֤ζ𤬤ꤦ
     * OnBoardPlus 翼/2
     * OnBoardMinus 翼ʬѰդ롥
     */
    struct StateElements {
      FixedCapacityVector<OnBoardElement,32> myOnboardPlus;
      FixedCapacityVector<OnBoardElement,32> opOnboardPlus;
      FixedCapacityVector<OnBoardElement,64> myOnboardMinus;
      FixedCapacityVector<OnBoardElement,64> opOnboardMinus;
      StandElements stand;
    public:
      StateElements() {
      }
      void clear() {
      }
      /**
       * ꤬ptypeλ
       * ʬptypeλȤä
       */
      void addStand(Ptype ptype);
      /**
       * ꤬typeλȤä
       * ʬptypeλ
       */
      void subStand(Ptype ptype);
      /**
       * 
       */
      void addMyBoard(Position pos,PtypeO ptypeO);
      void subMyBoard(Position pos,PtypeO ptypeO);
      void addOpBoard(Position pos,PtypeO ptypeO);
      void subOpBoard(Position pos,PtypeO ptypeO);
      /**
       * ʬmove˽äƹ
       */
      void addMyMove(Move move);
      /**
       * move˽äƹ
       */
      void addOpMove(Move move);
      /**
       * ̤ʤ
       */
      bool isLoop() const{
	return myOnboardPlus.size()==0 && opOnboardPlus.size()==0 &&
	  myOnboardMinus.size()==0 && opOnboardMinus.size()==0;
      }
      /**
       * PˤSimpleMoveǽ
       */
      template<Player P>
      bool validSimpleMove(NumEffectState const& state,OnBoardElement const& fromElement,OnBoardElement const& toElement) const;
      /**
       * statelastMoveܤ̤ǡ
       * PˤSimpleMoveǽ
       */
      template<Player P>
      bool validSimpleMove(NumEffectState const& state,OnBoardElement const& fromElement,OnBoardElement const& toElement,Move lastMove) const;
      /**
       * PˤcaptureMoveǽ
       */
      template<Player P>
      bool validCaptureMove(NumEffectState const& state, OnBoardElement const& fromElement,OnBoardElement const& toElement,OnBoardElement const& captureElement) const;
      /**
       * statelastMoveܤ̤ǡ
       * PˤCaptureMoveǽ
       */
      template<Player P>
      bool validCaptureMove(NumEffectState const& state, OnBoardElement const& fromElement,OnBoardElement const& toElement,OnBoardElement const& captureElement,Move lastMove) const;
      /**
       * Pmove򤹤2nmoveؤκʬreject뤫ɤ롥
       * player˼äͭʻϤ -> false
       * player˼äʻϤ
       *   ʬʤ -> ѥ+» -> true
       *   ʬʬʬλ -> μ꤬2n˲ǽʤtrue
       *   ʬʬλ -> move꤬ǽʤtrue
       * Ϥʤ
       *   ʬʤ -> ѥ
       *    notRootMoveλ true (rootʳǤϤPASSǤ)
       *    ǤʤȤ false
       *   ʬʬʬλ -> μ꤬2n˲ǽʤtrue
       *   ʬʬλ -> move꤬ǽ
       *    notRejectSennichiteλ false (ޤʲǽ)
       *    ǤʤȤ true (ͭäΥ󥹤Ѥʤ)
       */
      template<Player P>
      bool canReject(NumEffectState const& state,bool notRejectSennichite,bool notRootMove,Move lastMove) const;
    };
    std::ostream& operator<<(std::ostream&,OnBoardElement const&);
    std::ostream& operator<<(std::ostream&,StandElements const&);
    std::ostream& operator<<(std::ostream&,StateElements const&);
    class MoveStackRejections
    {
    public:
      /**
       * P - (mplayer)ΩȽ
       * state - m ¹Ԥξ
       * history - mޤޤʤεϿ
       * curDepth - õϤο
       * m - å
       * alpha - windowP˼äƤβ
       * checkCountOfAltP - ꤬Ϣ³λˤ³
       */
      template<Player P>
      static bool probe(NumEffectState const& state,MoveStack const& history,int curDepth,Move const& m,int alpha, int checkCountOfAltP);
    };
  }
}
#endif /* _MOVE_STACKREJECTIONS_H */
