#ifndef _INSTANCEMULTIPLIER_H
#define _INSTANCEMULTIPLIER_H
#include "osl/stat/sparseRegressionMultiplier.h"
#include "osl/stat/sparseInstance.h"
#include <valarray>
namespace osl
{
  namespace stat
  {
    class ActivityCount;
    typedef std::valarray<double> valarray_t;

    /**
     * instance ˺ܤ.
     * dimension -1 Ȥư.
     */
    class InstanceMultiplier : public SparseRegressionMultiplier
    {
    protected:
      const SparseInstanceVector& instances;
      const ActivityCount& activity;
      mutable unsigned int cur;
      const int threshold;
      valarray_t& weights;
      mutable double best_correlation;
      mutable unsigned int cur_iteration;
      mutable unsigned int best_iteration;
      const unsigned int reserve_for_validation;
      const char *filename;
    public:
      /**
       * @param dimension intercept ޤ᤿dimension
       */
      InstanceMultiplier(unsigned int dimension,
			 unsigned int reserve_for_validation,
			 const SparseInstanceVector& instances,
			 const ActivityCount& activity,
			 valarray_t& w, int t, const char *f);
      ~InstanceMultiplier();
      void printCurrentDate() const;
      void newIteration() const;
      bool getVectorX(unsigned int& num_elements, 
		      unsigned int *non_zero_indices, 
		      double *non_zero_values) const;
      virtual double validate() const = 0;
    };

  } // namespace stat
} // namespace osl

#endif /* _INSTANCEMULTIPLIER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
