/* allMobility.cc
 */
#include "osl/mobility/allMobility.h"
#include "osl/mobility/rookMobility.h"
#include "osl/mobility/bishopMobility.h"
#include "osl/mobility/lanceMobility.h"

int osl::mobility::
AllMobility::count(const NumEffectState& state, Piece p)
{
  const Player owner = p.owner();
  switch (p.ptype()) {
  case ROOK:
  case PROOK:
    return RookMobility::countHorizontalAll(owner, state, p)
      + RookMobility::countVerticalAll(owner, state, p);
  case BISHOP:
  case PBISHOP:
    return BishopMobility::countAll(owner, state, p);
  case LANCE:
    return LanceMobility::countAll(owner, state, p);
  default:
    return 0;
  }
}


/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
