#include "osl/checkmate/checkHashTable.h"
// #include "osl/checkmate/dominanceTable.h"
// #include "osl/checkmate/arrayCheckHashTable.h"
// #include "osl/checkmate/simpleCheckHashTable.h"
#include "osl/hash/hashKey.h"
#include "osl/pathEncoding.h"
#include "osl/misc/perfmon.h"
#include <boost/scoped_ptr.hpp>
#include <iostream>
#include <cstdlib>
#include <cstdio>

#define CHECK_HASH_TABLE CheckHashTable

using namespace osl;
using namespace osl::checkmate;
using namespace osl::misc;

inline HashKey makeKey(size_t i)
{
  HashKey result;
  result.setRandom();
  result.setSignature(1+i-i/4); // v[0] ޤ˽Ťʤ褦
  return result;
}

template <bool findAfter, bool findAgain>
void test(size_t n)
{
  // stack ֤ˤ礭
  boost::scoped_ptr<CHECK_HASH_TABLE> table(new CHECK_HASH_TABLE(BLACK));
  PerfMon clock;
  PathEncoding dummy;
  for (size_t i=0; i<n; ++i)
  {
    const HashKey& k = makeKey(i);
    /*CheckHashRecord *record =*/ table->allocate(k, PieceStand(), dummy);
    if (findAfter)
      table->find(k);
  }
  if (findAgain)
  {
    for (size_t i=0; i<n; ++i)
    {
      const HashKey& k = makeKey(i);
      table->find(k);
    }
  }
  clock.stop("total", n);
}

int main(int argc, char **argv)
{
  int numEntries=10000;
  extern char *optarg;
  bool findAgain = false;
  bool findAfter = false;
  
  char c;
  while ((c = getopt(argc, argv, "fFn:")) != EOF)
  {
    switch(c)
    {
    case 'f':	findAfter = true;
      break;
    case 'F':	findAgain = true;
      break;
    case 'n':	numEntries = atoi(optarg);
      break;
    default:
      std::cerr << "unknown option\n";
      return 1;
    }
  }

  for (int i=0; i<8; ++i)
  {
    if (findAfter)
    {
      if (findAgain)
	test<true,true>(numEntries);
      else
	test<true,false>(numEntries);
    }
    else
    {
      if (findAgain)
	test<false,true>(numEntries);
      else
	test<false,false>(numEntries);
    }
  }
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
